void ProcessDialogEvent()
{
	ref NPChar, PChar, d;
	PChar = GetMainCharacter();
	aref Link, Diag;
	string NPC_Meeting;
	
	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makeref(d, Dialog);
	makearef(Diag, NPChar.Dialog);
	
	string iDay, iMonth, cargoid, questbookname;
	iDay = environment.date.day;
	iMonth = environment.date.month;
	string lastspeak_date = iday + " " + iMonth;
	ref ctown = GetCurrentTown();
	int chancecaught = 0;
	
	switch(Dialog.CurrentNode)
	{
		case "First time":
			if(CheckAttribute(pchar,"quest.mysterious_plants.declined"))
			{
				Link.l0 = DLG_TEXT[28];
				Link.l0.go = "agree_donate";
			}
			else
			{
				if(sti(GetAttribute(PChar,"quest.mysterious_plants.donate")) < 1000)
				{
					if(CheckAttribute(PChar,"quest.mysterious_plants.donate"))
					{
						Link.l0 = DLG_TEXT[94];
						Link.l0.go = "decline_donate_later";
					}
					else
					{
						Link.l0 = DLG_TEXT[0];
						Link.l0.go = "Trust Check";
					}
				}
				else
				{
					if(!CheckAttribute(PChar,"quest.mysterious_plants.heard_job"))
					{
						Link.l0 = DLG_TEXT[29];
						Link.l0.go = "Talk Business";
					}
				}
			}
			if(CheckAttribute(PChar,"quest.mysterious_plants.crewmember_killed") && GetAttribute(PChar,"quest.mysterious_plants.heard_job") == "explain")
			{
				Link.l0 = DLG_TEXT[55];
				Link.l0.go = "Meet In Tavern";
			}
			if(CheckAttribute(PChar,"quest.found_vegetal"))
			{
				Link.l1 = DLG_TEXT[64];
				Link.l1.go = "Explain Vegetal";
			}
		break;
		
		case "Explain Vegetal":
			AddDialogExitQuest("Finish Indian Treasure Quest");
			d.Text = DLG_TEXT[65];
			Link.l1 = DLG_TEXT[66];
			Link.l1.go = "exit";
		break;
		
		// ====================== PART 1
		
		case "Trust Check":
			d.Text = DLG_TEXT[1];
			Link.l1 = DLG_TEXT[2];
			Link.l1.go = "Convince"; 
		break;
		
		case "Convince":
			if(CheckAttribute(PChar,"quest.mysterious_plants"))
			{
				SetQuestHeader("plants");
				AddQuestRecord("plants", 1);
			}
			AddQuestRecord("plants", 2);
			d.Text = DLG_TEXT[3];
			Link.l1 = DLG_TEXT[4];
			Link.l1.go = "agree_donate";
			Link.l2 = DLG_TEXT[5];
			Link.l2.go = "decline_donate"; 			
		break;
		
		case "agree_donate":
			d.Text = DLG_TEXT[6];
			Link.l1 = DLG_TEXT[7];
			Link.l1.go = "exit";
			AddDialogExitQuest("Accept Donate Apothecary");			
		break;
		
		case "decline_donate":
			d.Text = DLG_TEXT[8];
			Link.l1 = DLG_TEXT[9];
			Link.l1.go = "exit";
			AddDialogExitQuest("Decline Donate Apothecary"); 			
		break;
		
		case "decline_donate_later":
			d.Text = DLG_TEXT[95];
			Link.l1 = DLG_TEXT[96];
			Link.l1.go = "exit";
			AddDialogExitQuest("Decline Donate Apothecary"); 			
		break;
		
		case "Killed Mob":
			d.Text = DLG_TEXT[22];
			Link.l1 = DLG_TEXT[23];
			Link.l1.go = "Killed Mob 2";
		break;
		
		case "Killed Mob 2":
			d.Text = DLG_TEXT[24];
			Link.l1 = DLG_TEXT[25];
			Link.l1.go = "Killed Mob 3";
		break;
		
		case "Killed Mob 3":
			AddDialogExitQuest("Officiant helps steven"); 
			d.Text = DLG_TEXT[26];
			Link.l1 = DLG_TEXT[27];
			Link.l1.go = "exit";
		break;
		
		//===================== PART 2
		case "Talk Business":
			AddDialogExitQuest("Apothecary Talk Business");
			d.Text = DLG_TEXT[30];
			Link.l1 = DLG_TEXT[31];
			Link.l1.go = "Talk Business 2";
		break;
		
		case "Talk Business 2":
			d.Text = DLG_TEXT[32];
			Link.l1 = DLG_TEXT[33];
			Link.l1.go = "Talk Business 3";
		break;
		
		case "Talk Business 3":
			d.Text = DLG_TEXT[34];
			Link.l1 = DLG_TEXT[35];
			Link.l1.go = "Talk Business 4";
		break;
		
		case "Talk Business 4":
			d.Text = DLG_TEXT[36];
			Link.l1 = DLG_TEXT[37];
			Link.l1.go = "Talk Business Accept";
			Link.l2 = DLG_TEXT[38];
			Link.l2.go = "Talk Business Decline";
		break;
		
		case "Talk Business Decline":
			d.Text = DLG_TEXT[39];
			Link.l1 = DLG_TEXT[40];
			Link.l1.go = "exit decline business";
			Link.l2 = DLG_TEXT[41];
			Link.l2.go = "Talk Business Reconsider";
		break;
		
		case "Talk Business Reconsider":
			d.Text = DLG_TEXT[42];
			Link.l1 = DLG_TEXT[37];
			Link.l1.go = "Talk Business Accept";
			Link.l2 = DLG_TEXT[38];
			Link.l2.go = "exit decline business";
		break;
		
		case "exit decline business":
			Diag.CurrentNode = Diag.TempNode;
			AddDialogExitQuest("Apothecary Decline Business");
			DialogExit();
		break;
		
		case "Talk Business Accept":
			Diag.CurrentNode = Diag.TempNode;
			AddDialogExitQuest("Talk Business Accept");
			DialogExit();
		break;
		
		case "Discuss Guarded":
			d.Text = DLG_TEXT[45];
			Link.l1 = DLG_TEXT[46];
			Link.l1.go = "Discuss Guarded 2";
		break;
		
		case "Discuss Guarded 2":
			AddDialogExitQuest("Prepare Apothecary Voyage");
			d.Text = DLG_TEXT[47];
			Link.l1 = DLG_TEXT[48];
			Link.l1.go = "exit";
		break;
		
		case "Meet In Tavern":
			AddDialogExitQuest("Apothecary Meet In Tavern");
			d.Text = DLG_TEXT[56];
			Link.l1 = DLG_TEXT[57];
			Link.l1.go = "exit";
		break;
		
		//===================== PART FROM MOB LEADER
		case "Mob Leader":
			d.Text = DLG_TEXT[10];
			Link.l1 = DLG_TEXT[11];
			Link.l1.go = "Choose Mob";
		break;
		
		case "Choose Mob":
			d.Text = DLG_TEXT[12];
			Link.l1 = DLG_TEXT[13];
			Link.l1.go = "Choose BOOM";
			if(sti(PChar.money)>=1000)
			{
				Link.l2 = DLG_TEXT[14];
				Link.l2.go = "Choose Money";
			}
			Link.l3 = DLG_TEXT[15];
			Link.l3.go = "Choose Fight";
		break;
		
		case "Choose BOOM":
			d.Text = DLG_TEXT[16];
			Link.l1 = DLG_TEXT[17];
			Link.l1.go = "exit2";
			AddDialogExitQuest("Apothecary BOOM"); 
		break;
		
		case "Choose Money":
			AddMoneyToCharacter(pchar, -1000);
			d.Text = DLG_TEXT[18];
			Link.l1 = DLG_TEXT[19];
			Link.l1.go = "exit2";
			AddDialogExitQuest("Apothecary Pay"); 
		break;
		
		case "Choose Fight":
			AddMoneyToCharacter(pchar, -1000);
			d.Text = DLG_TEXT[20];
			Link.l1 = DLG_TEXT[21];
			Link.l1.go = "exit2";
			AddDialogExitQuest("Apothecary Fight Mob"); 
		break;
		
		case "exit2":
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;
		
		//=================== Crew Member Part
		case "Crew Spotted Natives":
			d.Text = DLG_TEXT[43];
			Link.l1 = DLG_TEXT[44];
			Link.l1.go = "exit guarded";
		break;
		
		case "exit guarded":
			AddDialogExitQuest("Apothecary Discuss Guards"); 
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;
		
		case "Saved from Natives":
			AddDialogExitQuest("Apothecary Crewmember goes to ship");
			d.Text = DLG_TEXT[53];
			Link.l1 = DLG_TEXT[54];
			Link.l1.go = "exit2";
		break;
		
		case "Help During Ambush":
			AddDialogExitQuest("Continue Apothecary Ambush");
			d.Text = DLG_TEXT[67];
			Link.l1 = DLG_TEXT[68];
			Link.l1.go = "exit2";
		break;
		
		case "Won Ambush":
			AddDialogExitQuest("Apothecary Exit Warehouse");
			d.Text = DLG_TEXT[69];
			Link.l1 = DLG_TEXT[70];
			Link.l1.go = "exit2";
		break;
		
		//=================== Officiant Part
		case "Hit by Blast":
			d.Text = DLG_TEXT[49];
			Link.l1 = DLG_TEXT[50];
			Link.l1.go = "Hit by Blast 2";
		break;
		
		case "Hit by Blast 2":
			AddDialogExitQuest("ResurrectionEvent_OfficiantLeaves");
			d.Text = DLG_TEXT[51];
			Link.l1 = DLG_TEXT[52];
			Link.l1.go = "exit2";
		break;
		
		case "Help Steven Leave":
			d.Text = DLG_TEXT[60];
			Link.l1 = DLG_TEXT[61];
			Link.l1.go = "Help Steven Leave 2";
		break;
		
		case "Help Steven Leave 2":
			AddDialogExitQuest("Steven Leaves");
			d.Text = DLG_TEXT[62];
			Link.l1 = DLG_TEXT[63];
			Link.l1.go = "exit2";
		break;
		
		//================== Captain Part
		case "Talk about plan":
			AddDialogExitQuest("Apothecary Meet At Lighthouse");
			d.Text = DLG_TEXT[58];
			Link.l1 = DLG_TEXT[59];
			Link.l1.go = "exit2";
		break;
		
		case "Arrived at Lighthouse":
			AddDialogExitQuest("Apothecary Arrived at Lighthouse");
			d.Text = DLG_TEXT[88];
			Link.l1 = DLG_TEXT[89];
			Link.l1.go = "exit2";
		break;
		
		case "Ship Blow Up":
			AddDialogExitQuest("Apothecary Indians Attack at Lighthouse");
			d.Text = DLG_TEXT[90];
			Link.l1 = DLG_TEXT[91];
			Link.l1.go = "exit2";
		break;
		
		case "Depart To Columbia":
			d.Text = DLG_TEXT[92];
			Link.l1 = DLG_TEXT[93];
			Link.l1.go = "exit2";
		break;
		
		//================= Indians in warehouse part
		case "Indians Talk 1":
			PChar.quest.mysterious_plants.node = "Indians Talk 2";
			d.Text = DLG_TEXT[71];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
		break;
		
		case "Indians Talk 2":
			PChar.quest.mysterious_plants.node = "Indians Talk 3";
			d.Text = DLG_TEXT[75];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
		break;
		
		case "Indians Talk 3":
			PChar.quest.mysterious_plants.node = "Indians Talk 4";
			d.Text = DLG_TEXT[76];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
		break;
		
		case "Indians Talk 4":
			PChar.quest.mysterious_plants.node = "Indians Talk 5";
			d.Text = DLG_TEXT[77];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
		break;
		
		case "Indians Talk 5":
			AddQuestRecord("plants", 24);
			PChar.quest.mysterious_plants.node = "Indians Talk 7";
			d.Text = DLG_TEXT[78];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk 7":
			chancecaught = (2 - CalcCharacterSkill(PChar, SKILL_SNEAK)) * 10;
			if(rand(100) < chancecaught) PChar.quest.mysterious_plants.node = "Indians Talk Caught";
			else PChar.quest.mysterious_plants.node = "Indians Talk 8";
			d.Text = DLG_TEXT[79];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk 8":
			AddDialogExitQuest("Hide Indian Treasure");
			chancecaught = (15 - CalcCharacterSkill(PChar, SKILL_SNEAK)) * 10;
			if(rand(100) < chancecaught) PChar.quest.mysterious_plants.node = "Indians Talk Caught Treasure";
			else PChar.quest.mysterious_plants.node = "Indians Talk 9";
			d.Text = DLG_TEXT[80];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk 9":
			AddQuestRecord("indian_treasure", 1);
			chancecaught = (4 - CalcCharacterSkill(PChar, SKILL_SNEAK)) * 10;
			if(rand(100) < chancecaught) PChar.quest.mysterious_plants.node = "Indians Talk Caught";
			else PChar.quest.mysterious_plants.node = "Indians Talk 10";
			d.Text = DLG_TEXT[81];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk 10":
			chancecaught = (5 - CalcCharacterSkill(PChar, SKILL_SNEAK)) * 10;
			if(rand(100) < chancecaught) PChar.quest.mysterious_plants.node = "Indians Talk Caught";
			else PChar.quest.mysterious_plants.node = "Indians Talk 11";
			d.Text = DLG_TEXT[82];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk 11":
			chancecaught = (6 - CalcCharacterSkill(PChar, SKILL_SNEAK)) * 10;
			if(rand(100) < chancecaught) PChar.quest.mysterious_plants.node = "Indians Talk Caught";
			else 
			{
				if(sti(GetAttribute(pchar,"quest.mysterious_plants.indians.killed")) > 1)
				{
					PChar.quest.mysterious_plants.node = "Indians Talk 12b";
				}
				else
				{
					PChar.quest.mysterious_plants.node = "Indians Talk 12a";
				}
			}
			d.Text = DLG_TEXT[83];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk 12a":
			chancecaught = (7 - CalcCharacterSkill(PChar, SKILL_SNEAK)) * 10;
			if(rand(100) < chancecaught) PChar.quest.mysterious_plants.node = "Indians Talk Caught";
			else PChar.quest.mysterious_plants.node = "Indians Talk 13a";
			d.Text = DLG_TEXT[84];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk 13a":
			PChar.quest.mysterious_plants.node = "Indians Talk Caught";
			d.Text = DLG_TEXT[85];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk 12b":
			PChar.quest.mysterious_plants.node = "Indians Talk Caught";
			d.Text = DLG_TEXT[87];
			Link.l1 = DLG_TEXT[72];
			Link.l1.go = "Exit_Next_Person";
			Link.l2 = DLG_TEXT[73];
			Link.l2.go = "Exit_Fight_Indians";
			Link.l3 = DLG_TEXT[74];
			Link.l3.go = "Sneak away";
		break;
		
		case "Indians Talk Caught":
			d.Text = DLG_TEXT[86];
			Link.l1 = DLG_TEXT[73];
			Link.l1.go = "Exit_Fight_Spotted";
		break;
		
		case "Indians Talk Caught Treasure":
			AddQuestRecord("indian_treasure", 7);
			d.Text = DLG_TEXT[86];
			Link.l1 = DLG_TEXT[73];
			Link.l1.go = "Exit_Fight_Spotted";
		break;
		
		case "Exit_Next_Person":
			AddDialogExitQuest("Apothecary Sneak in Warehouse Dialog");
			DialogExit();
		break;
		
		case "Exit_Fight_Indians":
			AddDialogExitQuest("Apothecary Sneak in Warehouse Fight");
			DialogExit();
		break;
		
		case "Exit_Fight_Spotted":
			AddDialogExitQuest("Apothecary Sneak in Warehouse Spotted");
			DialogExit();
		break;
		
		case "Sneak away":
			AddDialogExitQuest("Apothecary Sneak in Warehouse Away");
			DialogExit();
		break;
	}
}